<?php namespace Myriad\NotifyClient\Client\FluentApi;

use Exception;
use Myriad\NotifyClient\Client;

class NotificationFluentApi
{

    private $notificationId;

    private $nsc;

    function __construct(Client $nsc, $notificationId = null)
    {
        $this->nsc = $nsc;
        $this->notificationId = $notificationId;
    }

    /**
     * @param $filter
     * @param  null  $sort
     * @param  null  $limit
     * @return array
     */
    public function query($filter, $sort = null, $limit = null): array
    {
        return $this->nsc->queryNotifications($filter, $sort, $limit);
    }

    /**
     * @param $notification
     * @return mixed
     * @throws Exception
     */
    public function create($notification)
    {
        return $this->nsc->createNotification($notification);
    }

    /**
     * @param $notificationId
     * @return mixed
     */
    public function get($notificationId)
    {
        return $this->nsc->getNotification($notificationId);
    }

    /**
     * @param $notification
     * @return mixed
     */
    public function update($notification)
    {
        return $this->nsc->updateNotification($notification, $this->notificationId);
    }

    /**
     * @param $notificationId
     * @return mixed
     */
    public function delete($notificationId)
    {
        return $this->nsc->deleteNotification($notificationId);
    }
}
