<?php

namespace Myriad\NotifyClient\Client\Helpers;

use Exception;
use Myriad\NotifyClient\Client\ValidatesAgainstConfig;
use Myriad\NotifyClient\Models\NotificationGroupRegistrant;
use Myriad\NotifyClient\Utilities\BuiltWithConfig;
use Myriad\NotifyClient\Utilities\HydratesModels;

class NotificationGroupRegistrantHelper
{

    use BuiltWithConfig;
    use HydratesModels;
    use ValidatesAgainstConfig;

    /**
     * @return string
     */
    protected function getItemClass(): string
    {
        return NotificationGroupRegistrant::class;
    }

    /**
     * @param $object
     * @return array
     * @throws Exception
     */
    public function makeArray($object): array
    {
        if ($object instanceof NotificationGroupRegistrant) {
            return $object->toArray();
        }
        if (is_array($object)) {
            return $object;
        }
        throw new Exception('Object must be a NotificationGroupRegistrant or array');
    }

    /**
     * @param  array  $array
     * @return bool
     */
    public function validate(array $array): bool
    {
        $this->maybeAssertSubscriptionsAreValid(data_get($array, 'subscriptions', []));
        return true;
    }

    /**
     * @param $uid
     * @param  null  $addl
     * @return string
     */
    public function uri($uid, $addl = null): string
    {
        return "notificationGroups/$uid/registrants".($addl ? "/$addl" : '');
    }
}
