<?php

namespace Myriad\NotifyClient\Utilities;

abstract class FluentBuilder
{

    protected $object;

    /**
     * @param $name
     * @param $arguments
     * @return $this
     */
    public function __call($name, $arguments): self
    {
        $this->object->{$name} = $arguments[0];
        return $this;
    }

    /**
     * @return FluentBuilder
     */
    public static function create(): self
    {
        return new static(...func_get_args());
    }
}
